// Code generated by tablegen. DO NOT EDIT.
package tables

func (t AllTables) UserStreaks() UserStreaks { return UserStreaks(t) }

type UserStreaks struct{ alias string }

func (t UserStreaks) TableAlias() string { return t.alias }
func (t UserStreaks) name() string       { return "UserStreaks" }
func (t UserStreaks) TableName() string  { return tableName(t.name(), "", t.alias) }
func (t UserStreaks) AllColumnNames() []string {
	c := t.Columns()
	return []string{
		c.ID(),
		c.UserID(),
		c.StreakID(),
		c.StartedAt(),
		c.PeriodDuration(),
		c.LastBlockEndsAt(),
		c.StreakLastsDuration(),
		c.CompletedBlocksCount(),
		c.LastBlockNumberOfEvents(),
		c.NumberOfEventsPerPeriod(),
	}
}

func (t UserStreaks) Columns() UserStreaksCols { return UserStreaksCols{tableAlias: t.alias} }

type UserStreaksCols struct{ tableAlias string }

func (c UserStreaksCols) ID() string              { return colName(c.tableAlias, "ID") }              // STRING(36)
func (c UserStreaksCols) UserID() string          { return colName(c.tableAlias, "UserID") }          // STRING(36)
func (c UserStreaksCols) StreakID() string        { return colName(c.tableAlias, "StreakID") }        // STRING(36)
func (c UserStreaksCols) StartedAt() string       { return colName(c.tableAlias, "StartedAt") }       // TIMESTAMP
func (c UserStreaksCols) PeriodDuration() string  { return colName(c.tableAlias, "PeriodDuration") }  // INT64
func (c UserStreaksCols) LastBlockEndsAt() string { return colName(c.tableAlias, "LastBlockEndsAt") } // TIMESTAMP
func (c UserStreaksCols) StreakLastsDuration() string {
	return colName(c.tableAlias, "StreakLastsDuration")
} // INT64 AS (TIMESTAMP_DIFF(LastBlockEndsAt, StartedAt, NANOSECOND)) STORED
func (c UserStreaksCols) CompletedBlocksCount() string {
	return colName(c.tableAlias, "CompletedBlocksCount")
} // INT64 AS (CAST(((StreakLastsDuration)/(PeriodDuration))-(IF(LastBlockNumberOfEvents < NumberOfEventsPerPeriod, 1, 0)) AS INT64)) STORED
func (c UserStreaksCols) LastBlockNumberOfEvents() string {
	return colName(c.tableAlias, "LastBlockNumberOfEvents")
} // INT64 DEFAULT (1)
func (c UserStreaksCols) NumberOfEventsPerPeriod() string {
	return colName(c.tableAlias, "NumberOfEventsPerPeriod")
} // INT64

func (t UserStreaks) Indexes() UserStreaksIndexes { return UserStreaksIndexes{table: t} }

type UserStreaksIndexes struct{ table UserStreaks }

func (i UserStreaksIndexes) ByStreakIDUserIDStartedAtDesc() Index {
	c := i.table.Columns()
	return Index{
		tableAlias: i.table.alias,
		tableName:  i.table.name(),
		indexName:  "UserStreaks_StreakID_UserID_StartedAt_DESC",
		columns: []string{
			c.ID(),
			c.UserID(),
			c.StreakID(),
			c.StartedAt(),
			c.PeriodDuration(),
			c.LastBlockEndsAt(),
			c.StreakLastsDuration(),
			c.CompletedBlocksCount(),
			c.LastBlockNumberOfEvents(),
			c.NumberOfEventsPerPeriod(),
		},
	}
}

func (i UserStreaksIndexes) ByStreakIDUserIDCompletedBlocksCountDesc() Index {
	c := i.table.Columns()
	return Index{
		tableAlias: i.table.alias,
		tableName:  i.table.name(),
		indexName:  "UserStreaks_StreakID_UserID_CompletedBlocksCount_DESC",
		columns: []string{
			c.ID(),
			c.UserID(),
			c.StreakID(),
			c.StartedAt(),
			c.PeriodDuration(),
			c.LastBlockEndsAt(),
			c.StreakLastsDuration(),
			c.CompletedBlocksCount(),
			c.LastBlockNumberOfEvents(),
			c.NumberOfEventsPerPeriod(),
		},
	}
}
